/* States */
peakApp
    .config(['$stateProvider', '$urlRouterProvider',
        function ($stateProvider, $urlRouterProvider) {
            // Use $urlRouterProvider to configure any redirects (when) and invalid urls (otherwise).
            $urlRouterProvider
                .when('/home', '/peak/home')
                .when('/peak', '/peak/home')
                .otherwise('/login');
            
            // State Configurations
            $stateProvider
                // Login Page
                .state("login", {
                    page_title: 'Peak - Login',
                    url: "/login",
                    templateUrl: 'views/login.html',
                    controller: 'Login'
                })
                // Errors
                .state("error", {
                    url: "/error",
                    abstract: true,
                    template: '<div ui-view autoscroll="false" class="mainView-animate"></div>'
                })
                // Errors > 404
                .state("error.404", {
                    url: "/404",
                    templateUrl: 'views/error.404.html'
                })
                // authenticated - Parent
                .state("peak", {
                    abstract: true,
                    url: '/peak',
                    templateUrl: 'views/authenticated.html'
                })
                // Peak
                .state('peak.home', {
                    page_title: 'Peak Admin - Peak Settings',
                    data: { ncyBreadcrumbLabel: 'Peak ' },
                    url: '/home',
                    templateUrl: 'views/peak.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  qrCode
                                    'assets/lib/jquery-qrcode-0.9.5/dist/jquery.qrcode.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'Peak'
                })

                // System Status page
                .state('peak.systemstatus', {
                    page_title: 'Peak - System Status',
                    data: {
                        ncyBreadcrumbLabel: 'System Status '
                    },
                    url: '/systemstatus',
                    templateUrl: 'views/systemstatus.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'systemStatus'
                })

                // network page
                .state('peak.network', {
                    page_title: 'Peak - Network Configuration',
                    data: {
                        ncyBreadcrumbLabel: 'Network Configuration '
                    },
                    url: '/network',
                    templateUrl: 'views/network.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'networkCtrl'
                })

                // Port1
                .state('peak.port0', {
                    page_title: 'Peak - Port 1',
                    data: {
                        ncyBreadcrumbLabel: 'Port 1 '
                    },
                    url: '/port1',
                    templateUrl: 'views/port0.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'port0'
                })

                // Port2
                .state('peak.port1', {
                    page_title: 'Peak - Port 2',
                    data: {
                        ncyBreadcrumbLabel: 'Port 2 '
                    },
                    url: '/port2',
                    templateUrl: 'views/port1.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'port1'
                })

                // Port3
                .state('peak.port2', {
                    page_title: 'Peak - Port 3',
                    data: {
                        ncyBreadcrumbLabel: 'Port 3 '
                    },
                    url: '/port3',
                    templateUrl: 'views/port2.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'port2'
                })

                // Port4
                .state('peak.port3', {
                    page_title: 'Peak - Port 4',
                    data: {
                        ncyBreadcrumbLabel: 'Port 4 '
                    },
                    url: '/port4',
                    templateUrl: 'views/port3.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',

                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'port3'
                })

                // digitalIO
                .state('peak.ports', {
                    page_title: 'Peak - Ports',
                    data: {
                        ncyBreadcrumbLabel: 'Ports '
                    },
                    url: '/devices',
                    templateUrl: 'views/ports.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'ports'
                })

                // digitalIO
                .state('peak.digitalio', {
                    page_title: 'Peak - Digital I/O',
                    data: {
                        ncyBreadcrumbLabel: 'Digital I/O '
                    },
                    url: '/digitalio',
                    templateUrl: 'views/digitalio.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'digitalioCtrl'
                })

                // analogIO
                .state('peak.analogio', {
                    page_title: 'Peak - Analog I/O',
                    data: {
                        ncyBreadcrumbLabel: 'Analog I/O '
                    },
                    url: '/analogio',
                    templateUrl: 'views/analogio.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'analogioCtrl'
                })

                // Audio
                .state('peak.audio', {
                    page_title: 'Peak - Audio',
                    data: {
                        ncyBreadcrumbLabel: 'Audio '
                    },
                    url: '/audio',
                    templateUrl: 'views/audio.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'audioCtrl'
                })
                
                // Location (GPS)
                .state('peak.gps', {
                    page_title: 'Peak - Location (GPS)',
                    data: {
                        ncyBreadcrumbLabel: 'Location (GPS) '
                    },
                    url: '/gps',
                    templateUrl: 'views/gps.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'gpsCtrl'
                })

                // Access Control
                .state('peak.accessControl', {
                    page_title: 'Peak - Access Control',
                    data: {
                        ncyBreadcrumbLabel: 'Access Control'
                    },
                    url: '/access',
                    templateUrl: 'views/accesscontrol.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'accessControl'
                })// Access Control


                // Metering
                .state('peak.metering', {
                    page_title: 'Peak - Power Metering',
                    data: {
                        ncyBreadcrumbLabel: 'Power Metering'
                    },
                    url: '/metering',
                    templateUrl: 'views/metering.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // c3 charts
                                    'assets/lib/d3/d3.min.js',
                                    'assets/lib/c3/c3.min.js',
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'meteringControl'
                })// Power Metering

                // Serial I/O
                .state('peak.serial', {
                    page_title: 'Peak - Serial I/O',
                    data: {
                        ncyBreadcrumbLabel: 'Serial I/O '
                    },
                    url: '/serialio',
                    templateUrl: 'views/serialio.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'serialioCtrl'
                })

                // Logging page
                .state('peak.logging', {
                    page_title: 'Peak - Logging',
                    data: {
                        ncyBreadcrumbLabel: 'Logging '
                    },
                    url: '/logging',
                    templateUrl: 'views/logging.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'loggingCtrl'
                })
                // advanced page
                .state('peak.advanced', {
                    page_title: 'Peak - Advanced',
                    data: {
                        ncyBreadcrumbLabel: 'Advanced Features '
                    },
                    url: '/advanced',
                    templateUrl: 'views/advanced.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js',
                                    //  socket.io
                                    'node_modules/socket.io/node_modules/socket.io-client/socket.io.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'advancedCtrl'
                })
                // Dashboard
                .state("peak.dashboard", {
                    // this state page title
                    page_title: 'Peak Admin - Dashboard',
                    // this state url
                    url: "/dashboard",
                    templateUrl: 'views/dashboard.html',
                    data: {
                        ncyBreadcrumbLabel: 'Home'
                    },
                    // load state specific js/css
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // c3 charts
                                    'assets/lib/d3/d3.min.js',
                                    'assets/lib/c3/c3.min.js',
                                    // vector maps
                                    'assets/lib/jvectormap/jquery-jvectormap-1.2.2.min.js',
                                    'assets/lib/jvectormap/maps/jquery-jvectormap-world-mill-en.js',
                                    // countUp animation
                                    'assets/js/countUp.min.js',
                                    // switchery
                                    'assets/lib/switchery/dist/switchery.min.js',
                                    // easePie chart
                                    'assets/lib/easy-pie-chart/dist/jquery.easypiechart.min.js',
                                    // dashboard functions
                                    'assets/angular/states_jquery/yukon_dashboard.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'dashboardCtrl'
                })
                // Forms (parent state)
                .state('peak.forms', {
                    // With abstract set to true, that means this state can not be explicitly activated.
                    abstract: true,
                    url: '/forms',
                    template: '<div ui-view autoscroll="false" class="mainView-animate"></div>'
                })
                // Forms > Regular Elements
                .state('peak.forms.regular_elements', {
                    page_title: 'Yukon Admin - Forms Regular Elements',
                    data: {
                        ncyBreadcrumbLabel: 'Regular Elements'
                    },
                    // this url is appended to parent url (/forms/regular_elements)
                    url: '/regular_elements',
                    templateUrl: 'views/forms.regular_elements.html'
                })
                // Forms > Extended Elements
                .state('peak.forms.extended_elements', {
                    page_title: 'Yukon Admin - Forms Extended Elements',
                    data: {
                        ncyBreadcrumbLabel: 'Extended Elements'
                    },
                    url: '/extended_elements',
                    templateUrl: 'views/forms.extended_elements.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // select2
                                    'assets/lib/select2/select2.css',
                                    'assets/lib/select2/select2.min.js',
                                    // datepicker
                                    'assets/lib/bootstrap-datepicker/css/datepicker3.css',
                                    'assets/lib/bootstrap-datepicker/js/bootstrap-datepicker.js',
                                    // date range picker
                                    'assets/lib/bootstrap-daterangepicker/daterangepicker-bs3.css',
                                    'assets/lib/bootstrap-daterangepicker/daterangepicker.js',
                                    // rangeSlider
                                    'assets/lib/ion.rangeSlider/css/ion.rangeSlider.css',
                                    'assets/lib/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css',
                                    'assets/lib/ion.rangeSlider/js/ion-rangeSlider/ion.rangeSlider.min.js',
                                    // switchery
                                    'assets/lib/switchery/dist/switchery.min.js',
                                    // autosize
                                    'assets/lib/autosize/jquery.autosize.min.js',
                                    // inputmask
                                    'assets/lib/jquery.inputmask/jquery.inputmask.bundle.min.js',
                                    // maxlength for textareas
                                    'assets/lib/stopVerbosity/stopVerbosity.min.js',
                                    // uplaoder
                                    'assets/lib/plupload/js/jquery.plupload.queue/css/jquery.plupload.queue.css',
                                    'assets/lib/plupload/js/plupload.full.min.js',
                                    'assets/lib/plupload/js/jquery.plupload.queue/jquery.plupload.queue.min.js',
                                    // forms extended elements
                                    'assets/angular/states_jquery/yukon_extended_elements.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'formExtendedCtrl'
                })
                // Forms > Gridform
                .state('peak.forms.gridform', {
                    page_title: 'Yukon Admin - Gridform',
                    data: {
                        ncyBreadcrumbLabel: 'Gridform'
                    },
                    url: '/gridform',
                    templateUrl: 'views/forms.gridform.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // gridforms
                                    'assets/lib/gridforms/gf-forms.min.css',
                                    'assets/lib/gridforms/gf-forms.min.js'
                                ]);
                            }
                        ]
                    }
                })
                // Forms > Validation
                .state('peak.forms.validation', {
                    page_title: 'Yukon Admin - Form Validation',
                    data: {
                        ncyBreadcrumbLabel: 'Validation'
                    },
                    url: '/validation',
                    templateUrl: 'views/forms.validation.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // validation
                                    'assets/js/parsley.config.js',
                                    'assets/lib/parsley/dist/parsley.min.js',
                                    // select2
                                    'assets/lib/select2/select2.css',
                                    'assets/lib/select2/select2.min.js',
                                    // wysiwg editor
                                    'assets/lib/ckeditor/ckeditor.js',
                                    'assets/lib/ckeditor/adapters/jquery.js',
                                    // form validation functions
                                    'assets/angular/states_jquery/yukon_validation.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'formValidationCtrl'
                })
                // Forms > Wizard
                .state('peak.forms.wizard', {
                    page_title: 'Yukon Admin - Wizard',
                    data: {
                        ncyBreadcrumbLabel: 'Wizard'
                    },
                    url: '/wizard',
                    templateUrl: 'views/forms.wizard.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  prism highlight
                                    'assets/lib/prism/prism_default.css',
                                    'assets/lib/prism/line_numbers.css',
                                    'assets/lib/prism/prism.min.js',
                                    // select2
                                    'assets/lib/select2/select2.css',
                                    'assets/lib/select2/select2.min.js',
                                    // jquery steps
                                    'assets/js/jquery.steps.custom.min.js',
                                    // validation
                                    'assets/js/parsley.config.js',
                                    'assets/lib/parsley/dist/parsley.min.js',
                                    // form wizard functions
                                    'assets/angular/states_jquery/yukon_wizard.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'formWizardCtrl'
                })
                // Pages (parent state)
                .state('peak.pages', {
                    abstract: true,
                    template: '<div ui-view autoscroll="false" class="mainView-animate"></div>'
                })
                // Pages > Chat
                .state('peak.pages.chat', {
                    page_title: 'Yukon Admin - Chat',
                    data: {
                        ncyBreadcrumbLabel: 'Chat'
                    },
                    url: '/chat',
                    templateUrl: 'views/pages.chat.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  chat functions
                                    'assets/angular/states_jquery/yukon_chat.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'chatCtrl'
                })
                // Pages > Faq/Help
                .state('peak.pages.helpFaq', {
                    page_title: 'Yukon Admin - Help/Faq',
                    data: {
                        ncyBreadcrumbLabel: 'Help/Faq'
                    },
                    abstract: true,
                    url: '/help_faq',
                    templateUrl: 'views/pages.helpFaq.html',
                    controller: 'helpFaqCtrl'
                })
                // Pages > Faq/Help > Categories
                .state('peak.pages.helpFaq.all', {
                    page_title: 'Yukon Admin - Help/Faq (All)',
                    data: {
                        ncyBreadcrumbLabel: 'All',
                        ncyBreadcrumbParent: 'peak.pages.helpFaq'
                    },
                    url: '',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                .state('peak.pages.helpFaq.customerService', {
                    page_title: 'Yukon Admin - Help/Faq (Customer Service)',
                    data: {
                        ncyBreadcrumbLabel: 'Customer Service'
                    },
                    url: '/customer_service',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                .state('peak.pages.helpFaq.configurationDataManagement', {
                    page_title: 'Yukon Admin - Help/Faq (Configuration & Data Management)',
                    data: {
                        ncyBreadcrumbLabel: 'Configuration & Data Management'
                    },
                    url: '/configuration_data_management',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                .state('peak.pages.helpFaq.mobile', {
                    page_title: 'Yukon Admin - Help/Faq (Mobile)',
                    data: {
                        ncyBreadcrumbLabel: 'Mobile'
                    },
                    url: '/mobile',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                .state('peak.pages.helpFaq.reportsDashboard', {
                    page_title: 'Yukon Admin - Help/Faq (Reports & Dashboards)',
                    data: {
                        ncyBreadcrumbLabel: 'Reports & Dashboards'
                    },
                    url: '/reports_dashboard',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                .state('peak.pages.helpFaq.salesMarketing', {
                    page_title: 'Yukon Admin - Help/Faq (Sales & Marketing)',
                    data: {
                        ncyBreadcrumbLabel: 'Sales & Marketing'
                    },
                    url: '/sales_marketing',
                    templateUrl: 'views/pages.helpFaq.items.html'
                })
                // Pages > Invoices
                .state('peak.pages.invoices', {
                    page_title: 'Yukon Admin - Invoices',
                    data: {
                        ncyBreadcrumbLabel: 'Invoices'
                    },
                    url: '/invoices',
                    templateUrl: 'views/pages.invoices.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  qrCode
                                    'assets/lib/jquery-qrcode-0.9.5/dist/jquery.qrcode.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'invoicesCtrl'
                })
                // Pages > Mail
                .state('peak.pages.mail', {
                    data: {
                        ncyBreadcrumbLabel: 'Mailbox'
                    },
                    abstract: true,
                    url: '/mail',
                    templateUrl: 'views/pages.mail.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'mailboxCtrl'
                })
                // Pages > Mail > Inbox
                .state('peak.pages.mail.inbox', {
                    page_title: 'Yukon Admin - Inbox',
                    data: {
                        ncyBreadcrumbLabel: 'Inbox'
                    },
                    url: '',
                    templateUrl: 'views/pages.mail.messages.html'
                })
                // Pages > Mail > Sent
                .state('peak.pages.mail.sent', {
                    page_title: 'Yukon Admin - Inbox',
                    data: {
                        ncyBreadcrumbLabel: 'Sent'
                    },
                    url: '/sent',
                    templateUrl: 'views/pages.mail.messages.html'
                })
                // Pages > Mail > Spam
                .state('peak.pages.mail.spam', {
                    page_title: 'Yukon Admin - Inbox',
                    data: {
                        ncyBreadcrumbLabel: 'Spam'
                    },
                    url: '/spam',
                    templateUrl: 'views/pages.mail.messages.html'
                })
                // Pages > Mail > Drafts
                .state('peak.pages.mail.drafts', {
                    page_title: 'Yukon Admin - Drafts',
                    data: {
                        ncyBreadcrumbLabel: 'Drafts'
                    },
                    url: '/drafts',
                    templateUrl: 'views/pages.mail.messages.html'
                })
                // Pages > Mail > Spam
                .state('peak.pages.mail.trash', {
                    page_title: 'Yukon Admin - Trash',
                    data: {
                        ncyBreadcrumbLabel: 'Trash'
                    },
                    url: '/trash',
                    templateUrl: 'views/pages.mail.messages.html'
                })
                // Pages > Mail > Details
                .state('peak.pages.mail.details', {
                    page_title: 'Yukon Admin - Message',
                    data: {
                        ncyBreadcrumbLabel: 'Message'
                    },
                    url: '/details/{messageId:[0-9]{1,4}}',
                    templateUrl: 'views/pages.mail.details.html',
                    resolve: {
                        messageDetails: function ($http) {
                            return $http({ method: 'GET', url: 'data/mailbox.json' })
                                .then(function (data) {
                                    var messages = [],
                                        dataArr = data.data,
                                        dataLen = dataArr.length;
                                    for (var i = 0; i < dataLen; i++) {
                                        messages.push.apply(messages, dataArr[i]['messages']);
                                    }
                                    return messages;
                                });
                        }
                    },
                    controller: 'mailDetailsCtrl'
                })
                // Pages > Search
                .state('peak.pages.search', {
                    page_title: 'Yukon Admin - Search Page',
                    data: {
                        ncyBreadcrumbLabel: 'Search Page'
                    },
                    url: '/search',
                    templateUrl: 'views/pages.search.html'
                })
                // Pages > User List
                .state('peak.pages.userList', {
                    page_title: 'Yukon Admin - User List',
                    data: {
                        ncyBreadcrumbLabel: 'User List'
                    },
                    url: '/user_list',
                    templateUrl: 'views/pages.user_list.html',
                    resolve: {
                        userLists: function ($http) {
                            return $http({ method: 'GET', url: 'data/user_list.json' })
                                .then(function (data) {
                                    var userData = data.data;
                                    return userData;
                                });
                        },
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  iOS list
                                    'assets/lib/jquery-listnav/dist/js/jquery-listnav-2.4.0.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'userListCtrl'
                })
                // Pages > User Profile
                .state('peak.pages.userProfile', {
                    page_title: 'Yukon Admin - User Profile',
                    data: {
                        ncyBreadcrumbLabel: 'User Profile'
                    },
                    url: '/user_profile',
                    templateUrl: 'views/pages.user_profile.html',
                    // load state specific js/css
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // easePie chart
                                    'assets/lib/easy-pie-chart/dist/jquery.easypiechart.min.js',
                                    // dashboard functions
                                    'assets/angular/states_jquery/yukon_user_profile.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'userProfileCtrl'
                })
                // Components
                .state('peak.components', {
                    abstract: true,
                    url: '/components',
                    template: '<div ui-view autoscroll="false" class="mainView-animate"></div>'
                })
                // Components > Gallery
                .state('peak.components.gallery', {
                    page_title: 'Yukon Admin - Gallery',
                    data: {
                        ncyBreadcrumbLabel: 'Gallery'
                    },
                    url: '/gallery',
                    templateUrl: 'views/components.gallery.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // magnific popup
                                    'assets/lib/magnific-popup/magnific-popup.css',
                                    'assets/lib/magnific-popup/jquery.magnific-popup.min.js'
                                ]);
                            }
                        ],
                        images: function ($http) {
                            return $http({
                                method: 'GET', url: 'data/gallery_images.json'
                            })
                                .then(function (data) {
                                    var galleryData = data.data;
                                    return galleryData;
                                });
                        }
                    },
                    controller: 'galleryCtrl'
                })
                // Components > Grid
                .state('peak.components.grid', {
                    page_title: 'Yukon Admin - Grid',
                    data: {
                        ncyBreadcrumbLabel: 'Grid'
                    },
                    url: '/grid',
                    templateUrl: 'views/components.grid.html'
                })
                // Components > Icons
                .state('peak.components.icons', {
                    page_title: 'Yukon Admin - Icons',
                    data: {
                        ncyBreadcrumbLabel: 'Icons'
                    },
                    url: '/icons',
                    templateUrl: 'views/components.icons.html',
                    resolve: {
                        icons: function ($http) {
                            return $http({ method: 'GET', url: 'data/icons.json' })
                                .then(function (data) {
                                    var icons = data.data;
                                    return icons;
                                });
                        }
                    },
                    controller: function ($scope, $timeout, icons) {
                        $scope.icons = icons;
                    }
                })
                // Components > Notifications
                .state('peak.components.notificationsPopups', {
                    page_title: 'Yukon Admin - Notifications/Popups',
                    data: {
                        ncyBreadcrumbLabel: 'Notifications/Popups'
                    },
                    url: '/notifications',
                    templateUrl: 'views/components.notifications_popups.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // jBox
                                    'assets/lib/jBox-0.3.0/Source/jBox.css',
                                    'assets/lib/jBox-0.3.0/Source/themes/NoticeBorder.css',
                                    'assets/lib/jBox-0.3.0/Source/jBox.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'notificationsPopupsCtrl'
                })
                // Components > Bootstrap UI
                .state('peak.components.bootstrapUI', {
                    page_title: 'Yukon Admin - UI Bootstrap',
                    data: {
                        ncyBreadcrumbLabel: 'UI Bootstrap'
                    },
                    url: '/ui_bootstrap',
                    templateUrl: 'views/components.bootstrapUI.html',
                    controller: 'bootstrapUICtrl'
                })
                // Components > Typography
                .state('peak.components.typography', {
                    page_title: 'Yukon Admin - Typography',
                    data: {
                        ncyBreadcrumbLabel: 'Typography'
                    },
                    url: '/typography',
                    templateUrl: 'views/components.typography.html'
                })
                // Plugins > calendar
                .state('peak.plugins', {
                    abstract: true,
                    url: '/plugins',
                    template: '<div ui-view autoscroll="false" class="mainView-animate"></div>'
                })
                // Plugins > calendar
                .state('peak.plugins.calendar', {
                    abstract: true,
                    url: '/calendar',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // full calendar
                                    'assets/lib/fullcalendar/lib/jquery-ui.custom.min.js',
                                    'assets/lib/fullcalendar/fullcalendar.css',
                                    'assets/lib/fullcalendar/fullcalendar.min.js',
                                    'assets/lib/fullcalendar/gcal.js'
                                ]);
                            }
                        ]
                    },
                    templateUrl: 'views/plugins.calendar.html'
                })
                // Plugins > calendar > basic
                .state('peak.plugins.calendar.basic', {
                    page_title: 'Yukon Admin - Basic Calendar',
                    data: {
                        ncyBreadcrumbLabel: 'Basic Calendar'
                    },
                    url: '',
                    template: '<div class="row"> <div class="col-md-12"> <div id="calendar"></div> </div> </div>',
                    controller: 'calendarBasicCtrl'
                })
                // Plugins > calendar > lunar phases
                .state('peak.plugins.calendar.lunar', {
                    page_title: 'Yukon Admin - Phases of the Moon',
                    data: {
                        ncyBreadcrumbLabel: 'Phases of the Moon'
                    },
                    url: '/lunar_phases',
                    template: '<div class="row"> <div class="col-md-12"> <div id="calendar_phases"></div> </div> </div>',
                    controller: 'calendarLunarCtrl'
                })
                // Plugins > charts
                .state('peak.plugins.charts', {
                    page_title: 'Yukon Admin - Charts',
                    data: {
                        ncyBreadcrumbLabel: 'Charts'
                    },
                    url: '/charts',
                    templateUrl: 'views/plugins.charts.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // c3 charts
                                    'assets/lib/d3/d3.min.js',
                                    'assets/lib/c3/c3.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'chartsCtrl'
                })
                // Plugins > google maps
                .state('peak.plugins.googleMaps', {
                    page_title: 'Yukon Admin - Google Maps',
                    data: {
                        ncyBreadcrumbLabel: 'Google Maps '
                    },
                    url: '/google_maps',
                    templateUrl: 'views/plugins.gmaps.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // gmaps
                                    'assets/lib/gmaps/gmaps.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'gmapsCtrl'
                })
                // Plugins > tables
                .state('peak.plugins.tables', {
                    abstract: true,
                    url: '/tables',
                    templateUrl: 'views/plugins.tables.html'
                })
                // Plugins > tables > footables
                .state('peak.plugins.tables.footable', {
                    page_title: 'Yukon Admin - Footable',
                    data: {
                        ncyBreadcrumbLabel: 'Footable '
                    },
                    url: '',
                    templateUrl: 'views/plugins.tables.footable.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  footable
                                    'assets/lib/footable/css/footable.core.min.css',
                                    'assets/lib/footable/footable.min.js',
                                    'assets/lib/footable/footable.paginate.min.js',
                                    'assets/lib/footable/footable.filter.min.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'footablesCtrl'
                })
                // Plugins > tables > datatables
                .state('peak.plugins.tables.datatable', {
                    page_title: 'Yukon Admin - Datatables',
                    data: {
                        ncyBreadcrumbLabel: 'Datatables '
                    },
                    url: '/datatables',
                    templateUrl: 'views/plugins.tables.datatable.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    //  datatables
                                    'assets/lib/DataTables/media/js/jquery.dataTables.min.js',
                                    'assets/lib/DataTables/extensions/FixedHeader/js/dataTables.fixedHeader.min.js',
                                    'assets/lib/DataTables/media/js/dataTables.bootstrap.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'datatablesCtrl'
                })
                // Plugins > vector maps
                .state('peak.plugins.vectorMaps', {
                    page_title: 'Yukon Admin - Vector Maps',
                    data: {
                        ncyBreadcrumbLabel: 'Vector Maps '
                    },
                    url: '/vector_maps',
                    templateUrl: 'views/plugins.vector_maps.html',
                    resolve: {
                        files: [
                            'uiLoad',
                            function (uiLoad) {
                                return uiLoad.load([
                                    // vector maps
                                    'assets/lib/jvectormap/jquery-jvectormap-1.2.2.min.js',
                                    'assets/lib/jvectormap/maps/jquery-jvectormap-world-mill-en.js',
                                    'assets/lib/jvectormap/maps/jquery-jvectormap-ca-mill-en.js'
                                ]);
                            }
                        ]
                    },
                    controller: 'vectorMapsCtrl'
                });
        }
    ]);